package main

import (
  "fmt"
  "os"
)

/* Data s, trova il minimo numero di caratteri da aggiungere a s per rendela palindroma.
Restituisce tale numero insieme alla versione "palindromificata" di s. */
func minpalindroma(s string) (int,string) {
  if len(s) <= 1 {
    return 0, s
  }
  if s[0] == s[len(s) - 1] {
    ss := s[1:len(s)-1]
    n, zz := minpalindroma(ss)
    return n, string(s[0]) + zz + string(s[len(s)-1])
  } else {
    n1, zz1 := minpalindroma(s[1:len(s)])   // NANNA -> ANNA
    n2, zz2 := minpalindroma(s[0:len(s)-1]) // NANNA -> NANN
    if n1 < n2 {
      return n1 + 1, string(s[0]) + zz1 + string(s[0])
    } else {
      return n2 + 1, string(s[len(s)-1]) + zz2 + string(s[len(s)-1])
    }
  }
}

func main() {
  n, s := minpalindroma(os.Args[1])
  fmt.Printf("La stringa %s resa palindrom è %s (%d inserimenti)\n", os.Args[1], s, n)
}
