package main

import (
  "fmt"
  "os"
)

func palindroma(s string) bool {
  if len(s) <= 1 {
    return true
  }
  if s[0] != s[len(s) - 1] {
    return false
  }
  return palindroma(s[1:len(s)-1])
}

func palindromaBella(s string) bool {
  if len(s) <= 1 {
    return true
  }
  return s[0] == s[len(s)-1] && palindroma(s[1:len(s)-1])
}


func main() {
  if palindroma(os.Args[1]) {
    fmt.Printf("La stringa %s è palindroma\n", os.Args[1])
  } else {
    fmt.Printf("La stringa %s non è palindroma\n", os.Args[1])
  }
}
